#!/usr/bin/perl

package concat;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(concat);

use base_ops;

###################################################
# Concatenation
###################################################


sub concat {
	@_ == 4 || die("ERROR: too few/many arguments for concat()\n\tusage: concat(term1,bw1,term2,bw2)\n");
  
	local $term1 = $_[0];
	local $term1_bw = $_[1];
	local $term2 = $_[2];
	local $term2_bw = $_[3];

	local $result_bw = $term1_bw+$term2_bw;

	local $result = declareVar("concat_result", $result_bw);

	assert(
		equal(
			$term1,
			slice($result, $term1_bw+$term2_bw-1, $term2_bw)
	));

	assert(
		equal(
			$term2,
			slice($result, $term2_bw-1, 0)
	));

	return $result;
}


1;
