#!/bin/bash

if [[ "$#" -lt 3 ]]; then
  echo "Usage: ./ndist bw_min bw_max bw_step"
  exit 1
fi

# if [[ "$1" -lt 1 ]]; then
# 	echo "log2 of maximal bit-width must be greater equal than 1"
# 	exit 1
# fi

# if [[ "$#" -lt 2 ]]; then
#         n=2
# else
#         n=$2
# fi

# i=0
bw=$1
while [[ "$bw" -le "$2" ]]
do

mkdir -p ndist.a
OUT=ndist.a/ndist.a.$bw.smt2

echo "(set-logic QF_BV)" > $OUT
echo "(set-info :source |" >> $OUT
echo "We verify that (x < y) -> (x + 1 <= y)" >> $OUT
echo "Contributed by Andreas Froehlich, Gergely Kovasznai, Armin Biere" >> $OUT
echo "Institute for Formal Models and Verification, JKU, Linz, 2013" >> $OUT 
echo "source: http://fmv.jku.at/smtbench" >> $OUT
echo "|)" >> $OUT
echo "(set-info :smt-lib-version 2.0)" >> $OUT
echo "(set-info :category \"crafted\")" >> $OUT
echo "(set-info :status unsat)" >> $OUT

echo "(declare-fun x () (_ BitVec $bw))" >> $OUT
echo "(declare-fun y () (_ BitVec $bw))" >> $OUT
echo "(assert (bvult x y))" >> $OUT
echo "(assert (bvugt (bvadd x (_ bv1 $bw)) y))" >> $OUT
echo "(check-sat)" >> $OUT
echo "(exit)" >> $OUT

echo "... generated $OUT"

mkdir -p ndist.b
OUT=ndist.b/ndist.b.$bw.smt2

echo "(set-logic QF_BV)" > $OUT
echo "(set-info :source |" >> $OUT
echo "We give a counter-example for (x + 1 <= y) -> (x < y)" >> $OUT
echo "Contributed by Andreas Froehlich, Gergely Kovasznai, Armin Biere" >> $OUT
echo "Institute for Formal Models and Verification, JKU, Linz, 2013" >> $OUT
echo "source: http://fmv.jku.at/smtbench" >> $OUT
echo "|)" >> $OUT
echo "(set-info :smt-lib-version 2.0)" >> $OUT
echo "(set-info :category \"crafted\")" >> $OUT
echo "(set-info :status sat)" >> $OUT

echo "(declare-fun x () (_ BitVec $bw))" >> $OUT
echo "(declare-fun y () (_ BitVec $bw))" >> $OUT
echo "(assert (bvuge x y))" >> $OUT
echo "(assert (bvule (bvadd x (_ bv1 $bw)) y))" >> $OUT
echo "(check-sat)" >> $OUT
echo "(exit)" >> $OUT

echo "... generated $OUT"

# ((i += 1))
((bw += $3))
done



