#!/bin/bash

if [[ "$#" -lt 3 ]]; then
  echo "Usage: ./power2bit bw_min bw_max bw_step"
  exit 1
fi

bw=$1
while [[ "$bw" -le "$2" ]]
do

i=`echo "l($bw)/l(2)" | bc -l`
i=${i/\.*}

mkdir -p power2bit
OUT=power2bit/power2bit.$bw.smt2

echo "(set-logic QF_BV)" > $OUT
echo "(set-info :source |" >> $OUT
echo "Contributed by Andreas Froehlich, Gergely Kovasznai, Armin Biere" >> $OUT
echo "Institute for Formal Models and Verification, JKU, Linz, 2013" >> $OUT
echo "source: http://fmv.jku.at/smtbench" >> $OUT
echo "|)" >> $OUT
echo "(set-info :smt-lib-version 2.0)" >> $OUT
echo "(set-info :category \"crafted\")" >> $OUT
echo "(set-info :status unsat)" >> $OUT

echo "(declare-fun x () (_ BitVec $bw))" >> $OUT
echo "(assert (= (bvand (bvsub x (_ bv1 $bw)) x) (_ bv0 $bw)))" >> $OUT
echo "(assert (= ((_ extract $i $i) x) (_ bv1 1)))" >> $OUT
echo "(assert (= ((_ extract $(($i + 1)) $(($i + 1))) x) (_ bv1 1)))" >> $OUT
echo "(check-sat)" >> $OUT
echo "(exit)" >> $OUT

echo "... generated $OUT"

((bw += $3))
done



