#!/bin/bash

if [[ "$#" -lt 3 ]]; then
  echo "Usage: ./power2sum bw_min bw_max bw_step"
  exit 1
fi

bw=$1
while [[ "$bw" -le "$2" ]]
do

mkdir -p power2sum
OUT=power2sum/power2sum.$bw.smt2

echo "(set-logic QF_BV)" > $OUT
echo "(set-info :source |" >> $OUT
echo "We verify that the sum of two distinct powers of two cannot be a power of two." >> $OUT
echo "Contributed by Andreas Froehlich, Gergely Kovasznai, Armin Biere" >> $OUT
echo "Institute for Formal Models and Verification, JKU, Linz, 2013" >> $OUT
echo "source: http://fmv.jku.at/smtbench" >> $OUT
echo "|)" >> $OUT
echo "(set-info :smt-lib-version 2.0)" >> $OUT
echo "(set-info :category \"crafted\")" >> $OUT
echo "(set-info :status unsat)" >> $OUT

echo "(declare-fun x () (_ BitVec $bw))" >> $OUT
echo "(declare-fun y () (_ BitVec $bw))" >> $OUT
echo "(declare-fun z () (_ BitVec $bw))" >> $OUT
echo "(assert (= z (bvadd x y)))" >> $OUT
echo "(assert (distinct x y))" >> $OUT
echo "(assert (and (distinct x (_ bv0 $bw)) (= (bvand x (bvsub x (_ bv1 $bw))) (_ bv0 $bw))))" >> $OUT
echo "(assert (and (distinct y (_ bv0 $bw)) (= (bvand y (bvsub y (_ bv1 $bw))) (_ bv0 $bw))))" >> $OUT
echo "(assert (and (distinct z (_ bv0 $bw)) (= (bvand z (bvsub z (_ bv1 $bw))) (_ bv0 $bw))))" >> $OUT
echo "(check-sat)" >> $OUT
echo "(exit)" >> $OUT

echo "... generated $OUT"

((bw += $3))
done



