#!/usr/bin/perl

package zero_extend;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(zero_extend);

use base_ops;
use concat;

###################################################
# Zero extension
###################################################


sub zero_extend {
	@_ == 3 || die("ERROR: too few/many arguments for zero_extend()\n\tusage: zero_extend(var,bw,bw_inc)\n");
  
	local $input = $_[0];
	local $bw = $_[1];
	local $bw_inc = $_[2];

	if ($bw_inc == 0) {
		return $input;
	}
	else {
		return concat(
			bvconst(0, $bw_inc), $bw_inc,
			$input, $bw
		);
	}
}


sub test_zero_extend {
	@_ == 3 || die("ERROR: too few/many arguments for test_zero_extend()\n\tusage: test_zero_extend(var,bw,bw_inc)\n");	### INPUT VARIABLES


	### SMT HEADER

	printHeader();


	### INPUT VARIABLES

	local $input = $_[0];
	local $bw = $_[1];
	local $bw_inc = $_[2];

	local $input = declareVar($input, $bw);


	### RESULT BY SMT SOLVER

	local $result = declareVar("result", $bw+$bw_inc);
	assert(
		equal(
			$result,
			"((_ zero_extend $bw_inc) $input)"
	));


	### COMPARE RESULT BY OUR APPROACH

	assert(
		lnot(
			equal(
				$result,
				zero_extend($input, $bw, $bw_inc)
	)));


	### SMT FOOTER

	printFooter();
}
